pcl::registration::CorrespondenceRejectorFeatures Class Reference
Module registration

CorrespondenceRejectorFeatures implements a correspondence rejection method based on a set of feature descriptors. More...

`#include <pcl/registration/correspondence_rejection_features.h>`

Inheritance diagram for pcl::registration::CorrespondenceRejectorFeatures:

## Classes

class | FeatureContainer
| An inner class containing pointers to the source and target feature clouds and the parameters needed to perform the correspondence search. More...
class | FeatureContainerInterface

## Public Types

typedef boost::shared_ptr< CorrespondenceRejectorFeatures > | Ptr
typedef boost::shared_ptr< const CorrespondenceRejectorFeatures > | ConstPtr
Public Types inherited from pcl::registration::CorrespondenceRejector
typedef boost::shared_ptr< CorrespondenceRejector > | Ptr
typedef boost::shared_ptr< const CorrespondenceRejector > | ConstPtr

## Public Member Functions

| CorrespondenceRejectorFeatures ()
| Empty constructor. More...
virtual | ~CorrespondenceRejectorFeatures ()
| Empty destructor. More...
void | getRemainingCorrespondences (const pcl::Correspondences &original_correspondences, pcl::Correspondences &remaining_correspondences)
| Get a list of valid correspondences after rejection from the original set of correspondences. More...
template<typename FeatureT >
void | setSourceFeature (const typename pcl::PointCloud< FeatureT >::ConstPtr &source_feature, const std::string &key)
| Provide a pointer to a cloud of feature descriptors associated with the source point cloud. More...
template<typename FeatureT >
pcl::PointCloud< FeatureT >::ConstPtr | getSourceFeature (const std::string &key)
| Get a pointer to the source cloud's feature descriptors, specified by the given key. More...
template<typename FeatureT >
void | setTargetFeature (const typename pcl::PointCloud< FeatureT >::ConstPtr &target_feature, const std::string &key)
| Provide a pointer to a cloud of feature descriptors associated with the target point cloud. More...
template<typename FeatureT >
pcl::PointCloud< FeatureT >::ConstPtr | getTargetFeature (const std::string &key)
| Get a pointer to the source cloud's feature descriptors, specified by the given key. More...
template<typename FeatureT >
void | setDistanceThreshold (double thresh, const std::string &key)
| Set a hard distance threshold in the feature FeatureT space, between source and target features. More...
bool | hasValidFeatures ()
| Test that all features are valid (i.e., does each key have a valid source cloud, target cloud, and search method) More...
template<typename FeatureT >
void | setFeatureRepresentation (const typename pcl::PointRepresentation< FeatureT >::ConstPtr &fr, const std::string &key)
| Provide a boost shared pointer to a PointRepresentation to be used when comparing features. More...
Public Member Functions inherited from pcl::registration::CorrespondenceRejector
| CorrespondenceRejector ()
| Empty constructor. More...
virtual | ~CorrespondenceRejector ()
| Empty destructor. More...
virtual void | setInputCorrespondences (const CorrespondencesConstPtr &correspondences)
| Provide a pointer to the vector of the input correspondences. More...
CorrespondencesConstPtr | getInputCorrespondences ()
| Get a pointer to the vector of the input correspondences. More...
void | getCorrespondences (pcl::Correspondences &correspondences)
| Run correspondence rejection. More...
void | getRejectedQueryIndices (const pcl::Correspondences &correspondences, std::vector< int > &indices)
| Determine the indices of query points of correspondences that have been rejected, i.e., the difference between the input correspondences (set via setInputCorrespondences) and the given correspondence vector. More...
const std::string & | getClassName () const
| Get a string representation of the name of this class. More...
virtual bool | requiresSourcePoints () const
| See if this rejector requires source points. More...
virtual void | setSourcePoints (pcl::PCLPointCloud2::ConstPtr)
| Abstract method for setting the source cloud. More...
virtual bool | requiresSourceNormals () const
| See if this rejector requires source normals. More...
virtual void | setSourceNormals (pcl::PCLPointCloud2::ConstPtr)
| Abstract method for setting the source normals. More...
virtual bool | requiresTargetPoints () const
| See if this rejector requires a target cloud. More...
virtual void | setTargetPoints (pcl::PCLPointCloud2::ConstPtr)
| Abstract method for setting the target cloud. More...
virtual bool | requiresTargetNormals () const
| See if this rejector requires target normals. More...
virtual void | setTargetNormals (pcl::PCLPointCloud2::ConstPtr)
| Abstract method for setting the target normals. More...

## Protected Types

typedef boost::unordered_map< std::string, boost::shared_ptr< FeatureContainerInterface > > | FeaturesMap

## Protected Member Functions

void | applyRejection (pcl::Correspondences &correspondences)
| Apply the rejection algorithm. More...

## Protected Attributes

float | max_distance_
| The maximum distance threshold between two correspondent points in source <-> target. More...
FeaturesMap | features_map_
| An STL map containing features to use when performing the correspondence search. More...
Protected Attributes inherited from pcl::registration::CorrespondenceRejector
std::string | rejection_name_
| The name of the rejection method. More...
CorrespondencesConstPtr | input_correspondences_
| The input correspondences. More...

## Detailed Description

CorrespondenceRejectorFeatures implements a correspondence rejection method based on a set of feature descriptors.

Given an input feature space, the method checks if each feature in the source cloud has a correspondence in the target cloud, either by checking the first K (given) point correspondences, or by defining a tolerance threshold via a radius in feature space.

Author
  Radu B. Rusu

Definition at line 60 of file correspondence_rejection_features.h.

## Member Typedef Documentation

## ConstPtr

typedef boost::shared_ptr<const CorrespondenceRejectorFeatures> pcl::registration::CorrespondenceRejectorFeatures::ConstPtr

Definition at line 68 of file correspondence_rejection_features.h.

## FeaturesMap

typedef boost::unordered_map<std::string, boost::shared_ptr<FeatureContainerInterface> > pcl::registration::CorrespondenceRejectorFeatures::FeaturesMap

protected

Definition at line 164 of file correspondence_rejection_features.h.

## Ptr

typedef boost::shared_ptr<CorrespondenceRejectorFeatures> pcl::registration::CorrespondenceRejectorFeatures::Ptr

Definition at line 67 of file correspondence_rejection_features.h.

## Constructor & Destructor Documentation

## CorrespondenceRejectorFeatures()

pcl::registration::CorrespondenceRejectorFeatures::CorrespondenceRejectorFeatures | ( |  | ) |

inline

Empty constructor.

Definition at line 71 of file correspondence_rejection_features.h.

## ~CorrespondenceRejectorFeatures()

virtual pcl::registration::CorrespondenceRejectorFeatures::~CorrespondenceRejectorFeatures | ( |  | ) |

inline virtual

Empty destructor.

Definition at line 77 of file correspondence_rejection_features.h.

## Member Function Documentation

## applyRejection()

void pcl::registration::CorrespondenceRejectorFeatures::applyRejection | ( | pcl::Correspondences & | correspondences | ) |

inline protected virtual

Apply the rejection algorithm.

Parameters

  [out] | correspondences | the set of resultant correspondences.

Implements pcl::registration::CorrespondenceRejector.

Definition at line 144 of file correspondence_rejection_features.h.

## getRemainingCorrespondences()

void pcl::registration::CorrespondenceRejectorFeatures::getRemainingCorrespondences | ( | const pcl::Correspondences & | original_correspondences,
|  | pcl::Correspondences & | remaining_correspondences
| ) |  |

virtual

Get a list of valid correspondences after rejection from the original set of correspondences.

Parameters

  [in] | original_correspondences | the set of initial correspondences given
  [out] | remaining_correspondences | the resultant filtered set of remaining correspondences

Implements pcl::registration::CorrespondenceRejector.

## getSourceFeature()

template<typename FeatureT >

pcl::PointCloud< FeatureT >::ConstPtr pcl::registration::CorrespondenceRejectorFeatures::getSourceFeature | ( | const std::string & | key | ) |

inline

Get a pointer to the source cloud's feature descriptors, specified by the given key.

Parameters

  [in] | key | a string that uniquely identifies the feature (must match the key provided by setSourceFeature)

Definition at line 55 of file correspondence_rejection_features.hpp.

References features_map_, and pcl::registration::CorrespondenceRejectorFeatures::FeatureContainer< FeatureT >::getSourceFeature().

## getTargetFeature()

template<typename FeatureT >

pcl::PointCloud< FeatureT >::ConstPtr pcl::registration::CorrespondenceRejectorFeatures::getTargetFeature | ( | const std::string & | key | ) |

inline

Get a pointer to the source cloud's feature descriptors, specified by the given key.

Parameters

  [in] | key | a string that uniquely identifies the feature (must match the key provided by setTargetFeature)

Definition at line 75 of file correspondence_rejection_features.hpp.

References features_map_, and pcl::registration::CorrespondenceRejectorFeatures::FeatureContainer< FeatureT >::getTargetFeature().

## hasValidFeatures()

bool pcl::registration::CorrespondenceRejectorFeatures::hasValidFeatures | ( |  | ) |

inline

Test that all features are valid (i.e., does each key have a valid source cloud, target cloud, and search method)

## setDistanceThreshold()

template<typename FeatureT >

void pcl::registration::CorrespondenceRejectorFeatures::setDistanceThreshold | ( | double | thresh,
|  | const std::string & | key
| ) |  |

inline

Set a hard distance threshold in the feature FeatureT space, between source and target features.

Any feature correspondence that is above this threshold will be considered bad and will be filtered out.

Parameters

  [in] | thresh | the distance threshold
  [in] | key | a string that uniquely identifies the feature

Definition at line 85 of file correspondence_rejection_features.hpp.

References features_map_.

## setFeatureRepresentation()

template<typename FeatureT >

void pcl::registration::CorrespondenceRejectorFeatures::setFeatureRepresentation | ( | const typename pcl::PointRepresentation< FeatureT >::ConstPtr & | fr,
|  | const std::string & | key
| ) |  |

inline

Provide a boost shared pointer to a PointRepresentation to be used when comparing features.

Parameters

  [in] | key | a string that uniquely identifies the feature
  [in] | fr | the point feature representation to be used

Definition at line 97 of file correspondence_rejection_features.hpp.

References features_map_.

## setSourceFeature()

template<typename FeatureT >

void pcl::registration::CorrespondenceRejectorFeatures::setSourceFeature | ( | const typename pcl::PointCloud< FeatureT >::ConstPtr & | source_feature,
|  | const std::string & | key
| ) |  |

inline

Provide a pointer to a cloud of feature descriptors associated with the source point cloud.

Parameters

  [in] | source_feature | a cloud of feature descriptors associated with the source point cloud
  [in] | key | a string that uniquely identifies the feature

Definition at line 45 of file correspondence_rejection_features.hpp.

References features_map_.

## setTargetFeature()

template<typename FeatureT >

void pcl::registration::CorrespondenceRejectorFeatures::setTargetFeature | ( | const typename pcl::PointCloud< FeatureT >::ConstPtr & | target_feature,
|  | const std::string & | key
| ) |  |

inline

Provide a pointer to a cloud of feature descriptors associated with the target point cloud.

Parameters

  [in] | target_feature | a cloud of feature descriptors associated with the target point cloud
  [in] | key | a string that uniquely identifies the feature

Definition at line 65 of file correspondence_rejection_features.hpp.

References features_map_.

## Member Data Documentation

## features_map_

FeaturesMap pcl::registration::CorrespondenceRejectorFeatures::features_map_

protected

An STL map containing features to use when performing the correspondence search.

Definition at line 167 of file correspondence_rejection_features.h.

Referenced by getSourceFeature(), getTargetFeature(), setDistanceThreshold(), setFeatureRepresentation(), setSourceFeature(), and setTargetFeature().

## max_distance_

float pcl::registration::CorrespondenceRejectorFeatures::max_distance_

protected

The maximum distance threshold between two correspondent points in source <-> target.

If the distance is larger than this threshold, the points will not be ignored in the alignment process.

Definition at line 152 of file correspondence_rejection_features.h.

The documentation for this class was generated from the following files:

- /build/pcl-OilVEB/pcl-1.8.1+dfsg1/registration/include/pcl/registration/correspondence_rejection_features.h
- /build/pcl-OilVEB/pcl-1.8.1+dfsg1/registration/include/pcl/registration/impl/correspondence_rejection_features.hpp